# Contribution Guidelines

&nbsp; 

## How to contribute with a Pull Request (PR)

**Tip:bulb:: Working on your first Pull Request?** You can *freely* learn about it from [How to Contribute to an Open Source Project on GitHub][PR]

* **Use sensible commit messages:**
  * If your PR fixes a separate issue number, include it in the commit message.
  * Use a sensible number of commit messages as well(_don't overdo_).

* **Fork the project from the testing branch:**
  * PR must be a fork from [`testing`][testing-br] branch only.

* **Test, format & lint your code:**
  * PR must be tested, formatted & linted against [our library standards][test]. 

* **Follow the template and submit the Pull Request(PR):**
  * Add a brief but descriptive title for your PR.
  * Explain what the PR adds, fixes or improves.
  * Related screenshots are recommended.
  * Most important of all, *remember to fill the PR template*.

&nbsp; 

&nbsp; 

## Reporting an Issue

If you've found a new  bug or you've come up with some new feature which can make VidGear API even better, then:

* **Search the Docs and previous issues:**
  * Remember first search if the *issue has already been reported*. You may also find related information that may help to resolve the issue. 
  * Then, go comprehensively through [Wiki Documentation][wiki] and our [FAQ & Troubleshooting section][faq].

* **Report the Issue and follow the appropriate template:**
  * Add a brief but descriptive title for your issue.
  * Keep the issue phrasing in context of the problem.
  * Attach source-code/screenshots if you have one.
  * Make sure to turn `logging=True` in parameters of the respective API for getting debug output. 
  * Finally, raise it by *choosing the appropriate Issue Template*: [Bug report][bug], [Proposal][proposal], [Question][question].


&nbsp; 

&nbsp; 


## Join our Community Channel :people_holding_hands:

If you want to share some information, or you've come up with some new idea, or looking for the fastest way troubleshoot your problems, then please, join our [**Gitter ➶**][gitter] community channel.

&nbsp; 

&nbsp;

## Become Stargazer :star:

If you think VidGear library is helpful and would like to help in return - **then you can be a :star2:[STARGAZER][stars]:star2:**. _By starring this project, you're making it easier for others to find & trust this library._

&nbsp;

&nbsp;

## Donate to Project development :heart:

_Love using VidGear?_ Consider supporting the project to fund new features and improvements:


[![ko-fi][kofi-badge]][kofi]


<!--
Internal URLs
-->
[Coffee-badge]:https://abhitronix.github.io/img/vidgear/orange_img.png
[coffee]:https://www.buymeacoffee.com/2twOXFvlA
[kofi-badge]:https://www.ko-fi.com/img/githubbutton_sm.svg
[kofi]: https://ko-fi.com/W7W8WTYO
[wiki]:https://github.com/abhiTronix/vidgear/wiki
[PR]: https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github
[test]: https://github.com/abhiTronix/vidgear/tree/testing#testing-formatting--linting
[gitter]:https://gitter.im/vidgear/community?utm_source=badge&utm_medium=badge&utm_campaign=pr-badge
[faq]: https://github.com/abhiTronix/vidgear/wiki/FAQ-&-Troubleshooting
[testing-br]: https://github.com/abhiTronix/vidgear/tree/testing
[bug]: https://github.com/abhiTronix/vidgear/issues/new?labels=issue%3A+bug&template=bug_report.md
[proposal]: https://github.com/abhiTronix/vidgear/issues/new?labels=issue%3A+proposal&template=proposal.md
[question]: https://github.com/abhiTronix/vidgear/issues/new?labels=issue%3A+question&template=question.md
[stars]: https://github.com/abhiTronix/vidgear/stargazers